var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import { Component, createElement } from 'react';
import PropTypes from 'prop-types';
import hoistStatics from 'hoist-non-react-statics';

import { STORE_KEY } from '../constants';
import shallowEqual from '../utils/shallowEqual';

export default (function (mapStateToPropsFn, mapDispatchToPropsFn, mapCommitToPropsFn, mapGetterToPropsFn) {
  return function (WrappedComponent) {
    var _PresentationalCompon2;

    var PresentationalComponent = function (_Component) {
      _inherits(PresentationalComponent, _Component);

      function PresentationalComponent(props, context) {
        _classCallCheck(this, PresentationalComponent);

        var _this = _possibleConstructorReturn(this, (PresentationalComponent.__proto__ || Object.getPrototypeOf(PresentationalComponent)).call(this, props, context));

        _this.store = props[STORE_KEY] || context[STORE_KEY];
        _this.mappedState = mapStateToPropsFn && mapStateToPropsFn(_this.store.state, props);
        _this.mappedGetters = mapGetterToPropsFn && mapGetterToPropsFn(_this.store.getters, props);
        _this.state = Object.assign({}, _this.mappedState, mapDispatchToPropsFn && mapDispatchToPropsFn(_this.store.dispatch, props), mapCommitToPropsFn && mapCommitToPropsFn(_this.store.commit, props), _this.mappedGetters);
        if (_this.mappedState) {
          _this.store.subscribe(function (mutation, state) {
            var newState = {};
            // update state from store state
            var newMappedState = mapStateToPropsFn(state, _this.props);
            if (!shallowEqual(_this.mappedState, newMappedState)) {
              _this.mappedState = newMappedState;
              newState = Object.assign({}, newState, _this.mappedState);
            }

            // update state from store getters, if any
            if (_this.mappedGetters) {
              var newMappedGetters = mapGetterToPropsFn(_this.store.getters, _this.props);
              if (!shallowEqual(_this.mappedGetters, newMappedGetters)) {
                _this.mappedGetters = newMappedGetters;
                newState = Object.assign({}, newState, _this.mappedGetters);
              }
            }

            if (Object.keys(newState).length) {
              _this.setState(newState);
            }
          });
        }
        return _this;
      }

      _createClass(PresentationalComponent, [{
        key: 'render',
        value: function render() {
          return createElement(WrappedComponent, Object.assign({}, this.props, this.state), this.props.children);
        }
      }]);

      return PresentationalComponent;
    }(Component);

    PresentationalComponent.WrappedComponent = WrappedComponent;
    PresentationalComponent.contextTypes = _defineProperty({}, STORE_KEY, PropTypes.object);
    PresentationalComponent.propTypes = (_PresentationalCompon2 = {}, _defineProperty(_PresentationalCompon2, STORE_KEY, PropTypes.object), _defineProperty(_PresentationalCompon2, 'children', PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])), _PresentationalCompon2);
    PresentationalComponent.displayName = WrappedComponent.displayName || WrappedComponent.name || 'Component';

    return hoistStatics(PresentationalComponent, WrappedComponent);
  };
});